/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef CALLBACKS_H
#define CALLBACKS_H

#include <gnome.h>
#include <sys/types.h>
#include <signal.h>
#include <wait.h>
#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include <gtk/gtkdnd.h>
#include <glib.h>

#include "velocity-window.h"
#include "velocity-thumbnail.h"
#include "velocity-windowman.h"

extern GList*velocity_static_templates;

void velocity_menu_refresh_cb(GtkWidget*widget,gpointer user_data);
void velocity_menu_sorting_reorganize_cb(GtkWidget*widget,gpointer user_data);
void velocity_menu_sorting_dirs_first_cb(GtkWidget*widget,gpointer user_data);
void velocity_menu_sorting_cb(GtkWidget*widget,gpointer user_data);
void velocity_menu_clipboard(velocity_view*vview,GtkWidget*menu);
gboolean velocity_menu_openwith_cb(GtkMenuItem*widget,GdkEvent*event,gpointer*user_data);
void velocity_menu_openwith_other_cb(GtkMenuItem*widget,gpointer*user_data);
void velocity_menu_open_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_open_in_window_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_scripts_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_templates_new_cb(GtkDialog*dlg,gint response,gpointer user_data);
void velocity_menu_templates_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_templates_error_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_sendto_cb(GtkMenuItem*menuitem,gpointer user_data);
gboolean velocity_menu_newfolder_cb(const gchar*uri,const gchar*name);
void velocity_menu_file_types_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_preferences_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_set_animation_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_window_tree_cb(velocity_tree_item*vti,gpointer user_data);
void velocity_window_on_quit_cb(GtkWidget*w,GdkEvent*event,gpointer user_data);
void velocity_menu_cut_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_copy_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_paste_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_paste_link_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_trash_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_delete_cb(GtkWidget*menuitem,gpointer user_data);
void velocity_menu_rename_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_properties_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_file_quit_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_edit_selectall_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_help_about_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_show_hidden_cb(GtkMenuItem*menuitem,gpointer user_data);
void velocity_menu_empty_trash_cb(GtkMenuItem*mi,gpointer user_data);
void velocity_menu_tool_network_cb(GtkMenuItem*mi,gpointer user_data);
void velocity_menu_tool_applications_cb(GtkMenuItem*mi,gpointer user_data);
void velocity_menu_tool_preferences_cb(GtkMenuItem*mi,gpointer user_data);

/*Toolbar/Location bar*/
void velocity_toolbar_back_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_forward_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_up_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_stop_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_refresh_cb(GtkButton*button,gpointer user_data);
gboolean velocity_toolbar_refresh_click_cb(GtkButton*button,GdkEventButton*event,gpointer user_data);
void velocity_toolbar_cut_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_copy_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_paste_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_trash_cb(GtkButton*button,gpointer user_data);
gboolean velocity_toolbar_trash_click_cb(GtkButton*button,GdkEventButton*event,gpointer user_data);
void velocity_toolbar_undo_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_search_cb(GtkButton*button,gpointer user_data);
void velocity_toolbar_home_cb(GtkButton*button,gpointer user_data);
gboolean velocity_toolbar_home_click_cb(GtkButton*button,GdkEventButton*event,gpointer user_data);

/*Interaction with the view component*/
gint velocity_window_progress_cb(gpointer user_data);
void*velocity_window_on_behavior_event_cb(velocity_view*vview,velocity_view_behavior_event vevent,GdkEvent*event,velocity_vfs_obj*vfsobj,gpointer user_data);
void*velocity_window_on_status_event_cb(velocity_view*vview,velocity_view_status_event vevent,const char*uri,GnomeVFSResult result,gpointer user_data);

#endif
