/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef VELOCITY_CLIPBOARD_H
#define VELOCITY_CLIPBOARD_H

#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include "velocity-vfs-object.h"

/*Data*/
typedef enum{VELOCITY_CLIPBOARD_NULL=0,
	VELOCITY_CLIPBOARD_CUT,
	VELOCITY_CLIPBOARD_COPY,
	VELOCITY_CLIPBOARD_LINK,	/*Acts much like copy in every way except the resulting file will be a symlink to the original rather than a duplicate*/
	VELOCITY_CLIPBOARD_NUM}velocity_clipboard_mode;
typedef struct{
	velocity_clipboard_mode mode;	/*What mode to use*/
	char*uri_prefix;	/*URI Prefix for all files in data*/
	GList*items;	/*GList of pointers to velocity_vfs_obj's*/
}velocity_clipboard;

/*Functions*/
velocity_clipboard*velocity_clipboard_new(void);
void velocity_clipboard_set_details(velocity_clipboard*vclip,const char*uri_prefix,velocity_clipboard_mode);
void velocity_clipboard_prepend_file(velocity_clipboard*vclip,velocity_vfs_obj*obj);
void velocity_clipboard_remove_file(velocity_clipboard*vclip,velocity_vfs_obj*obj);
GList*velocity_clipboard_to_uri_list(velocity_clipboard*vclip);
GList*velocity_clipboard_get_unique_mime_types(velocity_clipboard*vclip);
gboolean velocity_clipboard_has_items(velocity_clipboard*vclip);
gboolean velocity_clipboard_has_multiple(velocity_clipboard*vclip);
void velocity_clipboard_flush(velocity_clipboard*vclip);
void velocity_clipboard_free(velocity_clipboard*vclip);

#endif
