/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_DITEM_H
#define VELOCITY_DITEM_H

#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <libgnome/gnome-desktop-item.h>
#include <libgnomeui/gnome-ditem-edit.h>
#include "velocity-module.h"

typedef struct{
	char*location;
	GtkWidget*window;
	GnomeDItemEdit*die;
}velocity_ditem_edit;

void velocity_ditem_edit_new(const char*location);
void velocity_ditem_edit_free(velocity_ditem_edit*vdie);

/*Static module support*/
extern VELOCITY_STATIC_MODULE_INFO_DEFINE(ditem);
extern VELOCITY_STATIC_MODULE_GUI_DEFINE(ditem);
velocity_module_return velocity_ditem_init(void);
void velocity_ditem_about(void);
void velocity_ditem_unload(void);
void*velocity_ditem_on_view_behavior_event(velocity_view*vview,velocity_view_behavior_event vevent,GdkEvent*event,velocity_vfs_obj*vfsobj,gpointer user_data);
#endif
