/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_FACTORIES_H
#define VELOCITY_FACTORIES_H

#include <glib.h>
#include "velocity-window.h"
#include "velocity-vfs.h"

/*Velocity Factory stuff*/
#define VELOCITY_FACTORY_TRUE	((gpointer)TRUE)
#define VELOCITY_FACTORY_FALSE	((gpointer)FALSE)

#define VELOCITY_MENU_FACTORY_PIXBUF_SIZE	16
#define VELOCITY_MENU_FACTORY_PIXBUF_LARGE_SIZE	32

#define VELOCITY_TOOLBAR_FACTORY_SIZE	24

/*The Velocity Menu Factory because GNOME's didn't like my passing of local variables.
	The format for the factorystream is a large list of different types.  See the defines for more
	detailed information.
*/
#define VELOCITY_MENU_FACTORY_SEPERATOR	((gpointer)1)	/*ARGS:  No args for this one*/
#define VELOCITY_MENU_FACTORY_CHECKBOX	((gpointer)2)	/*ARGS:  checked,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_PIXBUF	((gpointer)3)	/*ARGS:  image_uri,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_PIXBUF_LARGE	((gpointer)4)	/*ARGS:  image_uri,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_DIRECTORY	((gpointer)5)	/*ARGS: URI,filter,depth,show_self,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_SUBMENU	((gpointer)6)	/*ARGS:  submenu_widget,image_uri,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_SUBFACTORY	((gpointer)7)	/*ARGS:  void**subfactorystream,image_uri,text,enabled,cb,cb_data*/
#define VELOCITY_MENU_FACTORY_EMBEDDED_FACTORY	((gpointer)8)	/*ARGS:  void**subfactorystream*/
#define VELOCITY_MENU_FACTORY_NUM	8

//enum{VELOCITY_TOOLBAR_FACTORY_SEPERATOR=1,	/*ARGS:  No args for this one*/
//		VELOCITY_TOOLBAR_FACTORY_PIXBUF};	/*ARGS:  icon,caption,tooltip,callback,gtkwidget "ID" */
#define VELOCITY_TOOLBAR_FACTORY_SEPERATOR	((gpointer)1)	/*ARGS:  No args for this one*/
#define VELOCITY_TOOLBAR_FACTORY_PIXBUF	((gpointer)2)	/*ARGS:  icon,caption,tooltip,callback,gtkwidget "ID" */


/*This is used for dir -> menu factories.  Normally for internal use, but can come in handy*/
void velocity_menu_factory_directory_scan(GtkMenuItem*mi,const char*uri,velocity_vfs_filter_flags filter,
	guint depth,gboolean show_self,gboolean enabled,gpointer callback,gpointer callback_data);

GtkWidget*velocity_menu_factory(velocity_view*vview,GtkWidget*parent,void**factorystream);
void velocity_menu_factory_append(velocity_view*vview,GtkWidget*parent,void**factorystream);
GtkWidget*velocity_toolbar_factory(GtkWidget*parent,void**factorystream,gpointer user_data);
GtkWidget*velocity_toolbar_factory_get_button(GtkWidget*toolbar,const char*buttonname);

/*This just takes a list of strings*/
GtkWidget*velocity_option_menu_factory(gchar**vmnemonic);
#endif
