/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_FILE_PROPERTIES_WINDOW_H
#define VELOCITY_FILE_PROPERTIES_WINDOW_H

#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include "velocity-vfs.h"
#include "velocity-sys.h"
#include "velocity-view.h"

typedef enum{PERM_READ=0,
	PERM_WRITE,
	PERM_EXECUTE,
	PERM_NUM}velocity_properties_window_permission;

typedef struct {
	GtkWidget**Nobody;
	GtkWidget**Owner;
	GtkWidget**Group;
	GtkWidget**Other;
	GtkWidget**Everyone;
}permission_btns;

typedef struct{
	GtkWidget*window;
	GtkWidget*iconentry;
//TODO:  This should be a GList of velocity_vfs_obj*s
	velocity_vfs_obj*file_list;
//TODO:  This should be a GList of permission_btns, one per file
	permission_btns*permissions;
	velocity_view*view;	/*This is used for the emblems window*/
}velocity_file_properties;

/*Main/Data functions*/
permission_btns*new_permission_btns(void);
void free_permission_btns(permission_btns*);
GtkWidget*dlgFileProperties_new(velocity_vfs_obj*);
void dlgFileProperties_free(velocity_file_properties*v_props);


//TODO:  Thes should be static...
/*Callback functions*/
void dlgFileProperties_emblems_cb(GtkWidget*,gpointer user_data);

/*Nobody Permissions*/
void dlgFileProperties_on_chkNobodyR_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkNobodyW_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkNobodyX_cb(GtkToggleButton*,gpointer);
/*Owner Permissions*/
void dlgFileProperties_on_chkOwnerR_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOwnerW_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOwnerX_cb(GtkToggleButton*,gpointer);
/*Group Permissions*/
void dlgFileProperties_on_chkGroupR_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkGroupW_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkGroupX_cb(GtkToggleButton*,gpointer);
/*Other ppl's Permissions*/
void dlgFileProperties_on_chkOtherR_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOtherW_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOtherX_cb(GtkToggleButton*,gpointer);
/*Everyone Permissions*/
void dlgFileProperties_on_chkEveryoneR_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkEveryoneW_cb(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkEveryoneX_cb(GtkToggleButton*,gpointer);

#endif
