/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_THEME_H
#define VELOCITY_THEME_H

#include <glib.h>
#include "velocity-preferences.h"

/*Some basic icons used throughout the program*/
#define VELOCITY_ICON	"velocity.png"
#define VELOCITY_PREFS_BEHAVIOR	"behavior.png"
#define VELOCITY_PREFS_DESKTOP	"desktop.png"
#define VELOCITY_PREFS_THEMES	"themes.png"
#define VELOCITY_PREFS_ADVANCED	"advanced.png"
#define VELOCITY_PREFS_PUZZLE	"puzzle.png"
#define VELOCITY_PREFS_PUZZLE_PIECE	"puzzle-piece.png"
#define VELOCITY_PREFS_BIN	"bin.png"

/*Some useful GNOME icons*/
#define VELOCITY_HOME	"gnome-fs-home"
#define VELOCITY_ROOT	"gnome-dev-harddisk"
#define VELOCITY_NETWORK	"gnome-fs-network"
#define VELOCITY_DESKTOP	"gnome-fs-desktop"

#define VELOCITY_APPS	"gnome-logo-icon-transparent.png"
#define VELOCITY_PREFS	"control-center2.png"

#define VELOCITY_FOLDER	"gnome-fs-directory"
#define VELOCITY_FOLDER_ACCEPT	"gnome-fs-directory-accept"
#define VELOCITY_TRASH	"gnome-fs-trash-empty"
#define VELOCITY_TRASH_ACCEPT	"gnome-fs-trash-empty-accept"
#define VELOCITY_TRASH_FULL	"gnome-fs-trash-full"
#define VELOCITY_TRASH_FULL_ACCEPT	"gnome-fs-trash-full-accept"

#define VELOCITY_LOADING_ICON	"gnome-fs-loading-icon"
#define VELOCITY_DEFAULT_ICON	"gnome-fs-regular"
//#define VELOCITY_BROKEN_IMAGE_ICON	"broken-image-icon"

#define VELOCITY_EMBLEM_PREFIX	"emblem-"
#define VELOCITY_EMBLEM_SYMLINK		VELOCITY_EMBLEM_PREFIX "symbolic-link"
#define VELOCITY_EMBLEM_BROKEN_SYMLINK	VELOCITY_EMBLEM_PREFIX "trash"
#define VELOCITY_EMBLEM_NOREAD    VELOCITY_EMBLEM_PREFIX "noread"
#define VELOCITY_EMBLEM_ART	VELOCITY_EMBLEM_PREFIX "art"
#define VELOCITY_EMBLEM_CAMERA	VELOCITY_EMBLEM_PREFIX "camera"
#define VELOCITY_EMBLEM_DOCUMENTS	VELOCITY_EMBLEM_PREFIX "documents"
#define VELOCITY_EMBLEM_MAIL	VELOCITY_EMBLEM_PREFIX "mail"
#define VELOCITY_EMBLEM_MULTIMEDIA	VELOCITY_EMBLEM_PREFIX "multimedia"
#define VELOCITY_EMBLEM_NOTE	VELOCITY_EMBLEM_PREFIX "note"
#define VELOCITY_EMBLEM_PACKAGE	VELOCITY_EMBLEM_PREFIX "package"
#define VELOCITY_EMBLEM_PICTURES	VELOCITY_EMBLEM_PREFIX "pictures"
#define VELOCITY_EMBLEM_SOUND	VELOCITY_EMBLEM_PREFIX "sound"
#define VELOCITY_EMBLEM_TRASH	VELOCITY_EMBLEM_PREFIX "trash"
#define VELOCITY_EMBLEM_WEB	VELOCITY_EMBLEM_PREFIX "web"

#endif
