/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*This is our "lasso" (multiple file selection w/ mouse)*/

#include "velocity-lasso.h"

velocity_lasso*velocity_lasso_new(GnomeCanvasGroup*canvas_group,gfloat x1,gfloat y1,gfloat x2,gfloat y2,
	long fill_rgba,GdkBitmap*fill_stipple,long outline_rgba){
	velocity_lasso*vlasso=g_new(velocity_lasso,1);
	g_assert(vlasso!=NULL);
	vlasso->x1=0;
	vlasso->y1=0;
	vlasso->x2=0;
	vlasso->y2=0;
//	vlasso->lasso=NULL;
/*	vlasso->lasso=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_rect_get_type(),
					"x1",0.0, "y1",0.0, "x2",0.0, "y2",0.0,
					"fill_color_rgba",fill_rgba,
					"fill_stipple",fill_stipple,
					"outline_color_rgba",outline_rgba,
					"width_pixels",0.0,
					NULL);
*/
	vlasso->l=NULL;
	vlasso->t=NULL;
	vlasso->r=NULL;
	vlasso->b=NULL;

	//TODO:  "line_style", GdkLineStyle,    //this would be nice....
	vlasso->lpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(vlasso->lpts);
	vlasso->l=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
		"points",vlasso->lpts,
		"fill_color_rgba",outline_rgba,
		"width_units",1.0,
		NULL);
	vlasso->tpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(vlasso->tpts);
	vlasso->t=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
		"points",vlasso->tpts,
		"fill_color_rgba",outline_rgba,
		"width_units",1.0,
		NULL);
	vlasso->rpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(vlasso->rpts);
	vlasso->r=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
		"points",vlasso->rpts,
		"fill_color_rgba",outline_rgba,
		"width_units",1.0,
		NULL);
	vlasso->bpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(vlasso->bpts);
	vlasso->b=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
		"points",vlasso->bpts,
		"fill_color_rgba",outline_rgba,
		"width_units",1.0,
		NULL);
	velocity_lasso_moveto(vlasso,x1,y1,x2,y2);
	return(vlasso);
}

void velocity_lasso_moveto(velocity_lasso*vlasso,gfloat x1,gfloat y1,gfloat x2,gfloat y2){
	if(vlasso){
//		if(vlasso->lasso){
		if((vlasso->lpts)&&(vlasso->tpts)&&(vlasso->rpts)&&(vlasso->bpts)&&
			(vlasso->l)&&(vlasso->t)&&(vlasso->r)&&(vlasso->b)){
			int tmp;
			vlasso->x1=x1;
			vlasso->y1=y1;
			vlasso->x2=x2;
			vlasso->y2=y2;
			if(x2<x1){
				tmp=x1;
				x1=x2;
				x2=tmp;
			}
			if(y2<y1){
				tmp=y1;
				y1=y2;
				y2=tmp;
			}
			vlasso->fx1=x1;
			vlasso->fy1=y1;
			vlasso->fx2=x2;
			vlasso->fy2=y2;
			/*gnome_canvas_item_set(GNOME_CANVAS_ITEM(vlasso->lasso),
						"x1",x1,"y1",y1,
						"x2",x2,"y2",y2,
						NULL);
			*/
			vlasso->lpts->coords[0]=x1;
			vlasso->lpts->coords[1]=y1;
			vlasso->lpts->coords[2]=x1;
			vlasso->lpts->coords[3]=y2;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(vlasso->l),"points",vlasso->lpts,NULL);
			vlasso->tpts->coords[0]=x1;
			vlasso->tpts->coords[1]=y1;
			vlasso->tpts->coords[2]=x2;
			vlasso->tpts->coords[3]=y1;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(vlasso->t),"points",vlasso->tpts,NULL);
			vlasso->rpts->coords[0]=x2;
			vlasso->rpts->coords[1]=y1;
			vlasso->rpts->coords[2]=x2;
			vlasso->rpts->coords[3]=y2+1;	//TODO:  Why is this off by one?
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(vlasso->r),"points",vlasso->rpts,NULL);
			vlasso->bpts->coords[0]=x1;
			vlasso->bpts->coords[1]=y2;
			vlasso->bpts->coords[2]=x2;
			vlasso->bpts->coords[3]=y2;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(vlasso->b),"points",vlasso->bpts,NULL);
		}
	}
}

void velocity_lasso_free(velocity_lasso*vlasso){
        if(vlasso){
//                if(vlasso->lasso){
//			gtk_object_destroy(GTK_OBJECT(vlasso->lasso));
//			vlasso->lasso=NULL;
//                }
		if((vlasso->lpts)&&(vlasso->tpts)&&(vlasso->rpts)&&(vlasso->bpts)&&
			(vlasso->l)&&(vlasso->t)&&(vlasso->r)&&(vlasso->b)){
			gtk_object_destroy(GTK_OBJECT(vlasso->l));
			gtk_object_destroy(GTK_OBJECT(vlasso->t));
			gtk_object_destroy(GTK_OBJECT(vlasso->r));
			gtk_object_destroy(GTK_OBJECT(vlasso->b));
			vlasso->l=NULL;
			vlasso->t=NULL;
			vlasso->r=NULL;
			vlasso->b=NULL;
			gnome_canvas_points_unref(vlasso->lpts);
			gnome_canvas_points_unref(vlasso->tpts);
			gnome_canvas_points_unref(vlasso->rpts);
			gnome_canvas_points_unref(vlasso->bpts);
			vlasso->lpts=NULL;
			vlasso->tpts=NULL;
			vlasso->rpts=NULL;
			vlasso->bpts=NULL;
			g_free(vlasso);
		}
	}
}
