/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

//This is our "lasso" (multiple file selection w/ mouse)
//
#ifndef VELOCITY_LASSO_H
#define VELOCITY_LASSO_H

#include <glib.h>
#include <libgnomecanvas/libgnomecanvas.h>

typedef struct{
	gfloat x1;	//These are the un-"fixed" coordinates
	gfloat y1;
	gfloat x2;
	gfloat y2;
	gfloat fx1;	//These are the "fixed" coordinates (ie if fx1>fx2 then swap(fx1,fx2) etc..)  fx1 is always less than fx2, etc.
	gfloat fy1;
	gfloat fx2;
	gfloat fy2;
//	GnomeCanvasRE*lasso;
	GnomeCanvasPoints*lpts;
	GnomeCanvasLine*l;
	GnomeCanvasPoints*tpts;
	GnomeCanvasLine*t;
	GnomeCanvasPoints*rpts;
	GnomeCanvasLine*r;
	GnomeCanvasPoints*bpts;
	GnomeCanvasLine*b;
//TODO:  ideas for the future.....
//	GnomeCanvasPixbuf*handle_pixbuf;
}velocity_lasso;

velocity_lasso* velocity_lasso_new(GnomeCanvasGroup*canvas_group,gfloat x1,gfloat y1,gfloat x2,gfloat y2,long fill_rgba,GdkBitmap*fill_stipple,long outline_rgba);
void velocity_lasso_moveto(velocity_lasso*vlasso,gfloat x1,gfloat y1,gfloat x2,gfloat y2);
void velocity_lasso_free(velocity_lasso*vlasso);

#endif
