/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <config.h>
#include <libgnomeui/gnome-vfs-util.h>
#include <libgnomeui/gnome-thumbnail.h>
#include "velocity-sys.h"
#include "velocity-misc.h"
#include "velocity-module.h"
#include "velocity-factories.h"
#include "callbacks.h"

/*MODULE STUFF*/
static void velocity_misc_dir_menu_cb(GtkMenuItem*menuitem,guint uri_id){
	velocity_view*vview=(velocity_view*)g_object_get_data(G_OBJECT(menuitem),"velocity_view");	/*Always set by the factories for convenience*/
	velocity_vfs_filter_flags filter=VELOCITY_VFS_FILTER_HIDDEN|VELOCITY_VFS_FILTER_FILES;
	char*uri=(uri_id==0)?vprefs->locations->home:vprefs->locations->desktop;
	velocity_menu_factory_directory_scan(menuitem,uri,filter,2,TRUE,TRUE,G_CALLBACK(velocity_menu_sendto_cb),(gpointer)vview);
}

////TODO:
//static void velocity_misc_touch_cb(GtkMenuItem*menuitem,gpointer user_data){
//	velocity_view*vview=(velocity_view*)g_object_get_data(G_OBJECT(menuitem),"velocity_view");  /*Always set by the factories for convenience*/
//}
gpointer velocity_misc_module_gui_ext_sendto_home[]={VELOCITY_MENU_FACTORY_SUBMENU,NULL,VELOCITY_HOME,N_("_Home"),
		VELOCITY_FACTORY_TRUE,G_CALLBACK(velocity_misc_dir_menu_cb),(gpointer)0,
	NULL};
gpointer velocity_misc_module_gui_ext_sendto_desktop[]={VELOCITY_MENU_FACTORY_SUBMENU,NULL,VELOCITY_DESKTOP,N_("_Desktop"),
		VELOCITY_FACTORY_TRUE,G_CALLBACK(velocity_misc_dir_menu_cb),(gpointer)1,
	NULL};
gpointer velocity_misc_module_gui_ext_sendto[]={VELOCITY_MENU_FACTORY_EMBEDDED_FACTORY,velocity_misc_module_gui_ext_sendto_home,
	NULL};
gpointer velocity_misc_module_gui_ext_sendto_with_desktop[]={VELOCITY_MENU_FACTORY_EMBEDDED_FACTORY,velocity_misc_module_gui_ext_sendto_home,
	VELOCITY_MENU_FACTORY_EMBEDDED_FACTORY,velocity_misc_module_gui_ext_sendto_desktop,
	NULL};
//gpointer velocity_misc_module_gui_ext_addons[]={N_("Touch"),VELOCITY_FACTORY_TRUE,velocity_misc_touch_cb,NULL,
//	VELOCITY_MENU_FACTORY_EMBEDDED_FACTORY,velocity_image_module_gui_ext_addons_thm,
//	NULL};
VELOCITY_STATIC_MODULE_INFO_DEFINE(misc);
VELOCITY_STATIC_MODULE_GUI_DEFINE(misc);

velocity_module_return velocity_misc_init(void){
	VELOCITY_STATIC_MODULE_INFO(misc,_("Misc"),
		_("This module here only to make adding some static features to Velocity much simpler."),"http://velocity.sourceforge.net/");
	VELOCITY_STATIC_MODULE_VERSION(misc,1,0,0);
	VELOCITY_STATIC_MODULE_AUTHORS(misc,"Kyle Davis");
	VELOCITY_STATIC_MODULE_MIME_TYPES(misc,"internal/all");
	return(VELOCITY_MODULE_OK);
}
void velocity_misc_about(void){
}
void velocity_misc_unload(void){
}
void*velocity_misc_on_view_behavior_event(velocity_view*vview,velocity_view_behavior_event vevent,GdkEvent*event,velocity_vfs_obj*vfsobj,gpointer user_data){
	switch(vevent){
		case VELOCITY_VIEW_BEHAVIOR_EVENT_CONTEXT:
			if(velocity_windowman_desktop()){
				VELOCITY_STATIC_MODULE_GUI_VAR(misc).sendto=(gpointer*)velocity_misc_module_gui_ext_sendto_with_desktop;
			}else{
				VELOCITY_STATIC_MODULE_GUI_VAR(misc).sendto=(gpointer*)velocity_misc_module_gui_ext_sendto;
			}
			break;
		default:
			break;
	}
	return(NULL);
}
