/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_MODULE_PRIVATE_H
#define VELOCITY_MODULE_PRIVATE_H

#include <glib.h>
#include "velocity-module.h"

/*General utilities*/
gboolean velocity_module_is_dynamic(velocity_module*vmod);
gboolean velocity_module_supports_mime_type(velocity_module*vmod,const char*mime_type);

/*Module tracking system*/
GList*velocity_module_tracker_get_list(void);
velocity_module*velocity_module_tracker_register(const char* modname);
/*Module blacklist*/
void velocity_module_blacklist_add(const gchar*id);
void velocity_module_blacklist_remove(const gchar*id);
gboolean velocity_module_blacklist_check(const gchar*id);
/*It may be ugly, but neccessary (notice prefs callbacks not used for static modules*/
velocity_module*velocity_module_tracker_register_static(velocity_module_return(*init)(void),void(*about)(void),void(*unload)(void),
	velocity_module_info*info,velocity_module_gui_ext*gui_ext,
	velocity_view_status_event_ucb on_view_status_event,velocity_view_behavior_event_ucb on_view_behavior_event,
	velocity_module_viewer_new on_viewer_new,velocity_module_ext_callback on_viewer_free);
velocity_module*velocity_module_tracker_get(const char*modname);
gboolean velocity_module_tracker_unregister(velocity_module*vmod);
gboolean velocity_module_tracker_unregister_by_name(const gchar*modname);
void velocity_module_tracker_shutdown(void);

#endif
