/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
 
#ifndef VELOCITY_PREFERENCES_UTIL_H
#define VELOCITY_PREFERENCES_UTIL_H

#include <gtk/gtk.h>
#include "velocity-view.h"

typedef struct{
	GtkWidget*widget;
	GtkListStore*store;
	GtkTreeView*tree;
	GList*add;	/*List of newly added profiles*/
	GList*remove;	/*List of to be deleted profiles*/
}velocity_view_profile_manager_info;

GtkWidget*velocity_view_profile_manager_widget_new(void);
GtkWidget*velocity_view_profile_option_menu_new(const gchar*selected);
void velocity_view_profile_option_menu_update(GtkOptionMenu*om,const gchar*selected);
velocity_view_profile*velocity_view_profile_option_menu_get_profile(GtkOptionMenu*om);

#endif
