/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_PREFERENCES_WINDOW_H
#define VELOCITY_PREFERENCES_WINDOW_H

#include <glib.h>
#include <gtk/gtk.h>
#include "velocity-tree.h"
#include "velocity-sys.h"

typedef struct{
	GtkWidget*widget;	/*The window widget*/
	GtkWidget*pane;	/*our HPane*/
	GtkWidget*active;	/*The currently active dialog component*/
	GtkWidget*generic;	/*This is a generic "No Settings Here" label for tree items with out settings*/
	velocity_tree*tree;
}velocity_preferences_dialog;

typedef GtkWidget*(*velocity_preferences_dialog_component)(velocity_preferences_dialog*vprefsdlg,const gchar*vuri);
typedef void(*velocity_preferences_dialog_component_free)(velocity_preferences_dialog*vprefsdlg,GtkWidget*dlgcomponent,gint gtkresponse);
void velocity_preferences_window_new(GtkWidget*parent);
#endif
