/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_SCRIPT_H
#define VELOCITY_SCRIPT_H

#include <glib.h>

#define VELOCITY_SCRIPT_GET_INFO "--get-info"
#define VELOCITY_SCRIPT_FLAG_EXECUTE	"--execute"

typedef struct {
	char*file; /* full path to our actual script */
	char*name;
	char*version;
	char**authors;
	char*about;  /* this can be multilined, but we don't need to break it into a vector... */
	char**mime_types;
	gchar**dependancies;
	gchar**checked_dependancies;	/*We'll keep the checked version here as well...*/
	gboolean have_dependancies;
	gboolean needs_terminal;
	gboolean multiple_files;
	gboolean local_only;
	guint refcount;
} velocity_script;

velocity_script*velocity_script_new_from_file(const char*script);
velocity_script*velocity_script_dup(velocity_script*vscript);
void velocity_script_free(velocity_script*vscript);

#endif
