/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_VFSOBJECT_H
#define VELOCITY_VFSOBJECT_H

#include <libgnomevfs/gnome-vfs.h>
#include "velocity-icon.h"

typedef void(*velocity_vfs_obj_ext_destroy)(void*ext_data);	/*The ext->data, or the users data, is passed here*/
typedef struct{
	char*id;	/*ID of data handler*/
	gpointer data;	/*a pointer to the data that the data handler wants to pack into the velocity_vfs_obj*/
	velocity_vfs_obj_ext_destroy destroyucb;
}velocity_vfs_obj_ext;

typedef struct{
	char*prefix; /*Text URI Prefix*/
	GnomeVFSFileInfo*info;
	velocity_icon*icon;
	GList*extensions;	/*A list of velocity_vfs_obj_ext's (AVOID DIRECT ACCESS TO THIS)*/
	gpointer data;
	guint refcount;
}velocity_vfs_obj;

velocity_vfs_obj*velocity_vfs_obj_new(const char*uri,GnomeVFSFileInfo*info,velocity_icon*icon,gpointer data);
velocity_vfs_obj*velocity_vfs_obj_dup(velocity_vfs_obj*vfsobj);
void velocity_vfs_obj_ext_add(velocity_vfs_obj*vfsobj,const char*id,gpointer data,velocity_vfs_obj_ext_destroy destroyucb);
void velocity_vfs_obj_ext_remove(velocity_vfs_obj*vfsobj,const char*id);
gpointer*velocity_vfs_obj_ext_get_data(velocity_vfs_obj*vfsobj,const char*id);
gboolean velocity_vfs_obj_ext_set_data(velocity_vfs_obj*vfsobj,const char*id,gpointer data);	/*Returns whether it was updated or not*/
void velocity_vfs_obj_free(velocity_vfs_obj*vfsobj);
void velocity_vfs_obj_destroy(velocity_vfs_obj*vfsobj);

#endif
