/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*TODO:  Rename this file and rearrange some code...*/
/*TODO:  Split velocity_window into a velocity_window that uses a velocity_view...that way the desktop doesn't reinvent the wheel.*/
#ifndef INTERFACE_H
#define INTERFACE_H

#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include "velocity-icons.h"
#include "velocity-icon.h"
#include "velocity-lasso.h"
#include "velocity-tree.h"
#include "velocity-clipboard.h"
#include "velocity-preferences.h"
#include "velocity-view.h"

#define VELOCITY_WINDOW_HISTORY_LENGTH	256
#define VELOCITY_MODULE_URI_PREFIX	"module:"

typedef struct{
	GtkWidget*widget;	/*the main window*/
	GtkWidget*location;	/*location entry*/
	GtkWidget*btnGo;		/*the go button*/
	GtkWidget*menubar;	/*menu bar*/
	GtkWidget*toolbar;	/*toolbar*/
	GtkWidget*hpane;	/*The horizontal pane normally containing the tree on the left and the view on the right*/
	GtkWidget*optionmenu;	/*The view profile option menu*/

	/*a nice tree for easier directory management*/
	velocity_tree*tree;

	/*The main file management component, everything else is just a user interface*/
	velocity_view*view;

	/*handle for the progress handler (progress bar, status text, widget availability, etc.)*/
	guint progress_handle;

	/*A slight hack, we will need a subsystem to manage this later...*/
	//TODO:  Write this subsystem...maybe use code from vfs_ext subsystem...
	/*This (for now) handles any data that a module may wish to pack into our window*/
	GtkWidget*viewer;
	char*lasturi;
	
	/*ah yes, the Back and Forward buttons now have a use*/
	GList*history;
	GList*history_ptr;
}velocity_window;

velocity_window*velocity_window_new(void);
void velocity_window_menubar_create(velocity_window*vwin);
void velocity_window_toolbar_create(velocity_window*vwin);
void velocity_window_set_theme(velocity_window*vwin,const char*newtheme);
void velocity_window_update_location_entry(velocity_window*vwin,const char*location);
void velocity_window_set_location(velocity_window*vwin,const char*uri);
void velocity_window_show_lasso(velocity_window*vwin,gfloat x1,gfloat y1,gfloat x2,gfloat y2);
void velocity_window_hide_lasso(velocity_window*vwin);
void velocity_window_clear_selection(velocity_window*vwin);
void velocity_window_history_append_uri(velocity_window*vwin,const char*uri);
void velocity_window_history_back(velocity_window*vwin);
void velocity_window_history_forward(velocity_window*vwin);
void velocity_window_free(velocity_window*vwin);

#endif
