/*
 * Velocity - A GNOME File Manager
 *
 *
 * Copyright (C) (2002) (Kyle Davis) <kyled@blueriver.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef VELOCITY_WINDOWMAN_H
#define VELOCITY_WINDOWMAN_H

#include "velocity-window.h"

/*Multiple window managing code*/
typedef enum{VELOCITY_WINDOWMAN_INVALID=0,
		VELOCITY_WINDOWMAN_PASTE_ON,
		VELOCITY_WINDOWMAN_PASTE_OFF,
		VELOCITY_WINDOWMAN_NUM}velocity_windowman_set_type;

void velocity_windowman_new(const char*uri);
GList*velocity_windowman_list(void);
void velocity_windowman_set_all(velocity_windowman_set_type set);
void velocity_windowman_trees_register(const char*uri);
void velocity_windowman_trees_unregister(const char*uri);
void velocity_windowman_desktop_enable(void);
void velocity_windowman_desktop_disable(void);
velocity_view*velocity_windowman_desktop(void);

/*This will go through all windows (and optionally the desktop) and will call func with the velocity_view object for each*/
void velocity_windowman_foreach(gboolean include_desktop,GFunc func,gpointer user_data);

void velocity_windowman_free(velocity_window*vwin);
void velocity_windowman_free_all(void);
void velocity_windowman_shutdown(void);

#endif
